<template>
  <div>
    <game-search v-if="showSearch" :link="link" />
    <h2 class="is-size-4">
      <trophy v-if="isGameRanking"
              :type="$route.params.level"
              size="small" />
      <b-icon v-else
              :icon="icon" type="is-primary" />
      {{ title }}
      <template v-if="game && game.id">
        -
        <router-link :to="{ name: 'Game',
                            params: { id: game.id } }">
          {{ game.name }}
        </router-link>
      </template>
      <ul v-if="isGameRanking">
        <router-link v-for="trophy in trophies" :key="trophy"
                     :to="{ name: 'GamesRanking',
                            params: {
                              id: game.id,
                              level: trophy
                            } }">
          <li class="is-inline mx-3">
            <trophy :type="trophy"
                    size="small" />
          </li>
        </router-link>
      </ul>
    </h2>

    <b-table
      :data="scores"
      :striped="true"
      :loading="loading"
      :hoverable="true">

      <b-table-column field="rank"
                      centered
                      label="#"
                      v-slot="props">
        {{ props.index + 1 }}
      </b-table-column>

      <b-table-column field="player"
                      :label="$t('ranking.player')"
                      centered
                      v-slot="props">
        <router-link :to="{ name: 'User',
                            params: { id: props.row.user_id } }"
                      class="has-text-weight-bold has-text-green">
          {{ props.row.email }}
        </router-link>
      </b-table-column>

      <b-table-column field="value"
                      :label="$t('ranking.score')"
                      centered
                      v-slot="props">
        {{ $n(props.row.value) }}
      </b-table-column>

      <b-table-column v-if="link === 'Pantheon'"
                      field="date"
                      :label="$t('ranking.date')"
                      centered
                      v-slot="props">
          <span class="tag is-primary">
            {{ $d(new Date(props.row.created_at)) }}
          </span>
      </b-table-column>
    </b-table>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import LoadingMixin from '../../mixins/loading.vue';
import { Game } from '@/types/games';
import GameSearch from '@/components/games/GameSearch.vue';
import Trophy from '@/components/Trophy.vue';
import { Trophy as TrophyType  } from '@/types/scores';

@Component({
  components: { GameSearch, Trophy }
})
export default class BaseRanking extends LoadingMixin {
  showSearch: boolean = true;
  icon: string = '';
  title: string = '';
  link: string = '';
  game: Game = {
    id: 0,
    name: null,
    mode: 'action',
    pinned: false,
  };
  scores: { user_id: number, email: string;
            value: number }[] = [];
  trophies: TrophyType[] = Object.values(TrophyType);

  async mounted() {
    const { data } = await this.$http.get(this.endpoint);

    this.scores = data.scores;
    this.game = data.game;
    this.stopLoading();
  }

  get isGameRanking(): boolean {
    return this.link === 'GamesRanking';
  }

  get endpoint(): string {
    return '';
  }
}
</script>
